/**
  ******************************************************************************
  * @file    main.c
  * @author  Ac6
  * @version V1.0
  * @date    01-December-2013
  * @brief   Default main function.
  ******************************************************************************
*/


#include "stm32_ub_system.h"
#include "ub_xnet_l2.h"
			

int main(void)
{
	U32_DWORD tic = 0;
	U8_CHAR node_id;

	HAL_Init();

	UB_System_Init();

	UB_Xnet_L2_Init(0xB2);

	while(1) {
		UB_Xnet_L2_Loop();

		// wait until at least a second node is connected
		if(UB_Xnet_L2_Get_NetInfo(NETINFO_NR_NODES) > 1) {
			// wait 1 sec
			if(UB_Xnet_L2_Get_Tic() > tic+1000) {
				tic = UB_Xnet_L2_Get_Tic();
				// send ping to first node
				node_id = UB_Xnet_L2_Get_Node_ID(1);
				UB_Xnet_L2_Start_Ping_Node(node_id);
			}
		}
	}
}
