//-------------------------------------------------------------------
// File    : stm32_ub_gpio.c
// Author  : Uwe Becker
// Date    : 2018-01-14
// Version : 0.01
//
// Project : STM32
// Modul   : GPIO-Library
// GPIO-Library for STM32F103
//-------------------------------------------------------------------

#include "stm32_ub_gpio.h"



void UB_Gpio_Init_Output(GPIO_TypeDef *port, uint32_t pin, uint32_t pull, uint32_t speed)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	UB_System_GpioClockEnable(port);

	GPIO_InitStruct.Pin = pin;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
	GPIO_InitStruct.Pull = pull;
	GPIO_InitStruct.Speed = speed;
	HAL_GPIO_Init(port, &GPIO_InitStruct);
}

void UB_Gpio_Init_Input(GPIO_TypeDef *port, uint32_t pin, uint32_t pull, uint32_t speed)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	UB_System_GpioClockEnable(port);

	GPIO_InitStruct.Pin = pin;
	GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	GPIO_InitStruct.Pull = pull;
	GPIO_InitStruct.Speed = speed;
	HAL_GPIO_Init(port, &GPIO_InitStruct);
}

void UB_Gpio_Init_Output_AF(GPIO_TypeDef *port, uint32_t pin, uint32_t pull, uint32_t speed)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	UB_System_GpioClockEnable(port);

	GPIO_InitStruct.Pin = pin;
	GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
	GPIO_InitStruct.Pull = pull;
	GPIO_InitStruct.Speed = speed;
	HAL_GPIO_Init(port, &GPIO_InitStruct);
}

void UB_Gpio_Init_Input_AF(GPIO_TypeDef *port, uint32_t pin, uint32_t pull, uint32_t speed)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	UB_System_GpioClockEnable(port);

	GPIO_InitStruct.Pin = pin;
	GPIO_InitStruct.Mode = GPIO_MODE_AF_INPUT;
	GPIO_InitStruct.Pull = pull;
	GPIO_InitStruct.Speed = speed;
	HAL_GPIO_Init(port, &GPIO_InitStruct);
}

void UB_Gpio_Set(GPIO_TypeDef *port, uint32_t pin)
{
	HAL_GPIO_WritePin(port, pin, GPIO_PIN_SET);
}

void UB_Gpio_Reset(GPIO_TypeDef *port, uint32_t pin)
{
	HAL_GPIO_WritePin(port, pin, GPIO_PIN_RESET);
}

void UB_Gpio_Toggle(GPIO_TypeDef *port, uint32_t pin)
{
	HAL_GPIO_TogglePin(port, pin);
}

void UB_Gpio_Write(GPIO_TypeDef *port, uint32_t pin, uint8_t value)
{
	HAL_GPIO_WritePin(port, pin, value);
}

uint8_t UB_Gpio_Read(GPIO_TypeDef *port, uint32_t pin)
{
	uint8_t value;

	value = HAL_GPIO_ReadPin(port, pin);

	return value;
}
